%
% auto-detecting front-end
%
:- module(sockets,              [
				socket_create/2,	%create a socket
				socket_destroy/1,	%destroy a socket
				socket_bind/2,		%bind a socket to a name
				socket_listen/2,	%listen and set queue length
				socket_accept/4,	%accept incoming connection to a socket
				socket_connect/4,	%connect to remote
				socket_select/7,	%select between fds
				hostname/1		%get current hostname
				]).

:- use_module('util/prolog_detect').		%load Prolog detecting module
:- use_module('util/machine_type').		%load platform detecting module
:- use_module('util/flatten').			%load the list flattening module

:-	prolog_detect:prolog(Prolog),			%get Prolog type
	machine_type:get_machine_type(Machine),		%get machine type
	name(Machine,S1),
	name(Prolog,S2),
	name(sockets,S3),
	flatten([S1,"_",S2,"_",S3],S),			%compose file name string
	name(File,S),
	ensure_loaded(File).				%load file

