:- module(datetime,[get_current_datetime/1]).

:- use_module(prolog_detect).

:- prolog_detect:prolog(Prolog),
	(Prolog=quintus,
		use_module(library(date))
	);
	(Prolog=sicstus,
		use_module(library(system))
	).

get_current_datetime(Date_time) :-
	prolog(Prolog),
	get_date_time(Prolog,Date_time).

get_date_time(quintus,time_stamp(date(Day,Correct_month,Correct_year),time(Hour,Min,Sec))) :-
	date(date(Year,Month,Day)),
	Correct_year is Year+1900,
	Correct_month is Month+1,
	time(time(Hour,Min,Sec)).

get_date_time(sicstus,time_stamp(date(Day,Month,Year),time(Hour,Min,Sec))) :-
	datime(datime(Year,Month,Day,Hour,Min,Sec)).
